--------------------------------
-- HIGHLANDER BALANCED
-- original (highlander) by mikade, changes (balanced) by Luelle
--------------------------------


loadfile(GetDataPath() .. "Scripts/Locale.lua")()
loadfile(GetDataPath() .. "Scripts/Tracker.lua")()

local airWeapons =      {amAirAttack, amMineStrike, amNapalm, amDrillStrike, --[[amPiano]]}

local atkArray =        {
                                        amBazooka, amBee, --[[amMortar,]] amDrill, --[[amSnowball,]]
                                        amGrenade, amClusterBomb, amMolotov, --[[amWatermelon, amHellishBomb,]] amGasBomb,
                                        amShotgun, amDEagle, amFlamethrower, --[[amSniperRifle,]] amSineGun,
                                        amFirePunch, amWhip, amBaseballBat, --[[amKamikaze, amSeduction, amHammer,]]
                                        amMine, amDynamite, amCake, --[[amBallgun,]] amRCPlane, amSMine, amBirdy
                                        }

local utilArray =       {
                                        amBlowTorch, amPickHammer, amGirder, amPortalGun,
                                        amRope, --[[amParachute, amTeleport,]] amJetpack,
                                        amInvulnerable, --[[amLaserSight, amVampiric,]]
                                        amLowGravity, amExtraDamage, --[[amExtraTime,]]
                                        amLandGun
                                        --[[,amTardis, amResurrector, amSwitch]]
                                        }

local wepArray =        {}

local currName
local lastName
local started = false
local switchStage = 0

function onGearAdd(gear)

        --if GetGearType(gear) == gtSwitcher then
        --      SaveWeapons(CurrentHedgehog)
        --end

        if (GetGearType(gear) == gtHedgehog) then
                trackGear(gear)
        end

        if (GetGearType(gear) == gtRCPlane) then
             SetHealth(gear, 1)
        end

        if (GetGearType(gear) == gtKamikaze) then
             SetHealth(gear, 800)
        end

        if (GetGearType(gear) == gtCake) then
             SetHealth(gear, 800)
        end

end


function StartingSetUp(gear)

        for i = 1, #wepArray do
                setGearValue(gear,wepArray[i],0)
        end

        setGearValue(gear,amKamikaze,1)

        i = 1 + GetRandom(#atkArray)
        setGearValue(gear,atkArray[i],1)

        i = 1 + GetRandom(#utilArray)
        setGearValue(gear,utilArray[i],1)

        SetHealth(gear, 100)

end

--[[function SaveWeapons(gear)

        -
        for i = 1, (#wepArray) do
                setGearValue(gear, wepArray[i], GetAmmoCount(gear, wepArray[i]) )
                 --AddAmmo(gear, wepArray[i], getGearValue(gear,wepArray[i]) )
        end

end]]

function ConvertValues(gear)

        for i = 1, #wepArray do
                AddAmmo(gear, wepArray[i], getGearValue(gear,wepArray[i]) )
        end


end


function TransferWeps(gear)

        if CurrentHedgehog ~= nil then

                for i = 1, #wepArray do
                        val = getGearValue(gear,wepArray[i])
                        if val ~= 0 then
                                setGearValue(CurrentHedgehog, wepArray[i], val)
                                AddAmmo(CurrentHedgehog, wepArray[i], val)
                        end
                end

        end

end

function onGameInit()
        GameFlags = gfInfAttack + gfRandomOrder
        CaseFreq = 3
        HealthCaseProb = 50
        HealthCaseAmount = 25
end

function onGameStart()


        ShowMission     (
                                loc("HIGHLANDER BALANCED"),
                                loc("Not all hogs are born equal."),

                                "- " .. loc("Eliminate enemy hogs and take their weapons.") .. "|" ..
                                "- " .. loc("Balanced Version. Taken out strong and weak things.") .. "|" ..
                                "- " .. loc("New > crates including Teleporter, Rope, Vampirism or Tardis.") .. "|" ..
                                "- " .. loc("Cake runs only 8 sec, not 20.") .. "|" ..
                                "- " .. loc("RC Plane can only drop 1 bomb, not 3.") .. "|" ..
                                "- " .. loc("Kamikaze distance is halfed.") .. "|" ..
                                "- " .. loc("Per-Hog Ammo") .. "|" ..
                                "- " .. loc("Weapons reset.") .. "|" ..
                                "- " .. loc("Unlimited Attacks") .. "|" ..
                                "", 4, 4000
                                )


        if MapHasBorder() == false then
        for i, w in pairs(airWeapons) do
            table.insert(atkArray, w)
        end
    end

        for i, w in pairs(atkArray) do
        table.insert(wepArray, w)
        end

        for i, w in pairs(utilArray) do
        table.insert(wepArray, w)
        end

        runOnGears(StartingSetUp)
        runOnGears(ConvertValues)


end

function onNewTurn()
--
end


function onGameTick()

        if (CurrentHedgehog ~= nil) then

                currName = GetHogName(CurrentHedgehog)

                if (currName ~= lastName) then
                        AddCaption(loc("Switched to ") .. currName .. "!")
                        ConvertValues(CurrentHedgehog)
                end

                lastName = currName
        end

end

--[[function onHogHide(gear)
        -- waiting for Henek
end

function onHogRestore(gear)
        -- waiting for Henek
end]]



function onGearDelete(gear)

        if (GetGearType(gear) == gtHedgehog) then --or (GetGearType(gear) == gtResurrector) then
                TransferWeps(gear)
                trackDeletion(gear)
        end

end

function onAmmoStoreInit()

    SetAmmo(amTeleport, 0, 1, 0, 1)
    SetAmmo(amVampiric, 0, 1, 0, 1)
    SetAmmo(amRope, 0, 1, 0, 1)
    SetAmmo(amTardis, 0, 1, 0, 1)


        SetAmmo(amSkip, 9, 0, 0, 0)
        SetAmmo(amKamikaze, 9, 0, 0, 0)
        --SetAmmo(amSwitch, 9, 0, 0, 0) -------1
end
